CC = g++ 		   
NASM = nasm	
#NASM=nasmw 
TLIB = tlib
AR = ar 
ARFLAGS = rcs
#TLINK = g++ -Wl,-Map mintlib.map
TLINK = g++  -Wl
AFLAGS = -f elf	-i../include/   #  for Linux
#AFLAGS = -f coff -i../include/   #  for Linux
CFLAGS = -c -I../include		
#CFLAGS = -S -g  -I../include
#CFLAGS = -c	
LFLAGS  = -L../lib -lmint
SIQS = 1 
.c.o:
	  $(CC) {$< }

.cpp.o:
	  $(CC) -c {$< }
.asm.o:
	  $(NASM) $(AFLAGS)	 {$< }

OBJS =zetazero.o\
	zeta.o


#		*Explicit Rules*
ZETAZERO: $(OBJS) 
	$(TLINK) -o $@ $(OBJS) $(LFLAGS)  
	



zetazero.o:zetazero.cpp
	$(CC)	$(CFLAGS) zetazero.cpp

zeta.o:zeta.cpp
	$(CC) $(CFLAGS) zeta.cpp


