%include "mint.inc"
[BITS 32]
	public	@block_vector@$bctr$qxul
	extrn	@$bnwa$qui
	public	@block_vector@$bctr$qrx12block_vector
	extrn	memcpy
	public	@block_vector@$basg$qrx12block_vector
	extrn	@$bdla$qpv
	public	@block_vector@$bdtr$qv
	extrn	@$bdele$qpv
	public	@$blsh$qr7ostreamrx12block_vector
	extrn	@$blsh$qr7ostreamrx4TBit
	extrn	@endl$qr7ostream
	public	@block_vector@isMul$qrx12SparseMatrixrx12block_vector
	public	@block_vector@$bmul$qrx12block_vector
	public	@block_vector@isMul$qrx12block_vectort1
	public	@block_vector@isMulT$qrx12SparseMatrixrx12block_vector
	public	@block_vector@$badd$qrx12block_vector
	public	@block_vector@isAdd$qrx12block_vectort1
	public	@block_vector@isAND$qrx12block_vectorxul
	public	@block_vector@isZero$qv
	public	@block_vector@isIpro$qrx12block_vectort1
	public	@block_vector@$bmul$qxul
	extrn	@BitIndex$qpxulxl
	extrn	@BitOn$qpxulxl
	extrn	@BitOff$qpxulxl
	public	@block_vector@$beql$qrx12block_vector
	public	@Swap$qr12block_vectort1
	align	4
[SECTION .text]
@block_vector@$bctr$qxul
   ;	
   ;	block_vector::block_vector(const unsigned long _ndim):ndim(0),v(NULL)
   ;	
@1:
	push      ebp
	mov       ebp,esp
	mov       eax,dword ptr [ebp+8]
	xor       edx,edx
	mov       dword ptr [eax],edx
	mov       ecx,dword ptr [ebp+8]
	xor       eax,eax
	mov       dword ptr [ecx+4],eax
   ;	
   ;	{
   ;	    ndim=_ndim ;
   ;	
	mov       edx,dword ptr [ebp+12]
	mov       ecx,dword ptr [ebp+8]
	mov       dword ptr [ecx+4],edx
   ;	
   ;	    v=new unsigned long [ndim] ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	shl       edx,2
	push      edx
	call      @$bnwa$qui
	pop       ecx
	mov       ecx,dword ptr [ebp+8]
	mov       dword ptr [ecx],eax
   ;	
   ;	}
   ;	
	mov       eax,dword ptr [ebp+8]
@3:
@2:
	pop       ebp
	ret 

	align	4
@block_vector@$bctr$qrx12block_vector
   ;	
   ;	block_vector::block_vector(const block_vector& bv)
   ;	
@4:
	push      ebp
	mov       ebp,esp
   ;	
   ;	{
   ;	    ndim=bv.ndim ;
   ;	
	mov       eax,dword ptr [ebp+12]
	mov       ecx,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	mov       dword ptr [ecx+4],edx
   ;	
   ;	    v=new unsigned long[ndim] ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	shl       edx,2
	push      edx
	call      @$bnwa$qui
	pop       ecx
	mov       ecx,dword ptr [ebp+8]
	mov       dword ptr [ecx],eax
   ;	
   ;	    memcpy(v,bv.v,ndim*sizeof(unsigned long)) ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	shl       edx,2
	push      edx
	mov       ecx,dword ptr [ebp+12]
	mov       eax,dword ptr [ecx]
	push      eax
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx]
	push      ecx
	call      memcpy
	add       esp,12
   ;	
   ;	}
   ;	
	mov       eax,dword ptr [ebp+8]
@6:
@5:
	pop       ebp
	ret 
	align	4
@block_vector@$basg$qrx12block_vector
   ;	
   ;	block_vector& block_vector::operator=(const block_vector& bv)
   ;	
@7:
	push      ebp
	mov       ebp,esp
   ;	
   ;	{
   ;	    if( this==&bv ) return *this ;              // same
   ;	
	mov       eax,dword ptr [ebp+8]
	cmp       eax,dword ptr [ebp+12]
	jne       short @8
	mov       eax,dword ptr [ebp+8]
@13:
	pop       ebp
	ret 
   ;	
   ;	
   ;	    if( ndim==bv.ndim ) ;                               // same dimension
   ;	
@8:
	mov       edx,dword ptr [ebp+8]
	mov       eax,dword ptr [ebp+12]
	mov       ecx,dword ptr [edx+4]
	mov       edx,dword ptr [eax+4]
	cmp       ecx,edx
	je        short @10
   ;	
   ;	    else {
   ;	        if( v ) delete [] v ;                               // realloc
   ;	
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	test      eax,eax
	je        short @11
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx]
	push      ecx
	call      @$bdla$qpv
	pop       ecx
   ;	
   ;	        ndim=bv.ndim ;
   ;	
@11:
	mov       eax,dword ptr [ebp+12]
	mov       ecx,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	mov       dword ptr [ecx+4],edx
   ;	
   ;	        v=new unsigned long[ndim] ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	shl       edx,2
	push      edx
	call      @$bnwa$qui
	pop       ecx
	mov       ecx,dword ptr [ebp+8]
	mov       dword ptr [ecx],eax
   ;	
   ;	    }
   ;	    memcpy(v,bv.v,ndim*sizeof(unsigned long)) ;
   ;	
@10:
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	shl       edx,2
	push      edx
	mov       ecx,dword ptr [ebp+12]
	mov       eax,dword ptr [ecx]
	push      eax
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx]
	push      ecx
	call      memcpy
	add       esp,12
   ;	
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	}
   ;	
@12:
@9:
	pop       ebp
	ret 

	align	4
@block_vector@$bdtr$qv
   ;	
   ;	block_vector::~block_vector()
   ;	
@14:
	push      ebp
	mov       ebp,esp
	cmp       dword ptr [ebp+8],0
	je        short @15
   ;	
   ;	{
   ;	    if( v ) delete [] v ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax]
	test      edx,edx
	je        short @16
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	push      eax
	call      @$bdla$qpv
	pop       ecx
@16:
	test      byte ptr [ebp+12],1
	je        short @17
	mov       edx,dword ptr [ebp+8]
	push      edx
	call      @$bdele$qpv
	pop       ecx
   ;	
   ;	}
   ;	
@17:
@15:
@18:
	pop       ebp
	ret 

	align	4
@$blsh$qr7ostreamrx12block_vector
   ;	
   ;	::ostream& operator<<(::ostream& os,const block_vector& bvec)
   ;	
@19:
	push      ebp
	mov       ebp,esp
	add       esp,-20
   ;	
   ;	{
   ;	    TBit B ;
   ;	    for( unsigned long j=0 ; j<bvec.ndim ; j++ ) {
   ;	
@20:
	xor       eax,eax
	mov       dword ptr [ebp-4],eax
	jmp       short @22
   ;	
   ;	        B.SetBitString(WordSize,bvec.v+j) ;
   ;	
@21:
	mov       edx,dword ptr [ebp+12]
	mov       eax,dword ptr [ebp-4]
	shl       eax,2
	mov       ecx,dword ptr [edx]
	add       ecx,eax
	mov       edx,32
	mov       dword ptr [ebp-8],ecx
	mov       dword ptr [ebp-20],edx
	mov       ecx,dword ptr [ebp-20]
   ;	
   ;	        os << endl << B ;
   ;	
	lea       edx,[ebp-20]
	add       ecx,31
	sar       ecx,5
	mov       dword ptr [ebp-16],ecx
	mov       eax,dword ptr [ebp-8]
	mov       dword ptr [ebp-12],eax
	push      edx
	mov       ecx,dword ptr [ebp+8]
	push      ecx
	call      @endl$qr7ostream
	pop       ecx
	push      eax
	call      @$blsh$qr7ostreamrx4TBit
	add       esp,8
@23:
	inc       dword ptr [ebp-4]
@22:
	mov       eax,dword ptr [ebp+12]
	mov       edx,dword ptr [eax+4]
	mov       ecx,dword ptr [ebp-4]
	cmp       edx,ecx
	ja        short @21
   ;	
   ;	    }
   ;	    return os ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	}
   ;	
@26:
@25:
	mov       esp,ebp
	pop       ebp
	ret 

	align	4
@block_vector@isMul$qrx12SparseMatrixrx12block_vector
   ;	
   ;	block_vector& block_vector::isMul(const SparseMatrix& m,const block_vector& w)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-16
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	    bool same=(this==&w) ;
   ;	
@27:
	mov       eax,dword ptr [ebp+8]
	cmp       eax,dword ptr [ebp+16]
	sete      dl
	and       edx,1
	mov       byte ptr [ebp-1],dl
   ;	
   ;	    unsigned long* wv ;
   ;	    unsigned long j ;
   ;	    if( same ) {
   ;	
	mov       cl,byte ptr [ebp-1]
	test      cl,cl
	je        short @28
   ;	
   ;	        ndim=m.nrow ;
   ;	
	mov       eax,dword ptr [ebp+12]
	mov       ecx,dword ptr [ebp+8]
	mov       edx,dword ptr [eax]
	mov       dword ptr [ecx+4],edx
   ;	
   ;	        wv=new unsigned long[ndim] ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	shl       edx,2
	push      edx
	call      @$bnwa$qui
	pop       ecx
	mov       dword ptr [ebp-8],eax
   ;	
   ;	        unsigned long* temp ;
   ;	        temp=v ;
   ;	
@29:
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	mov       dword ptr [ebp-16],eax
   ;	
   ;	        v=wv ;
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [ebp-8]
	mov       dword ptr [edx],ecx
   ;	
   ;	        wv=temp ;
   ;	
	mov       eax,dword ptr [ebp-16]
	mov       dword ptr [ebp-8],eax
   ;	
   ;	    }
   ;	
@30:
	jmp       short @31
   ;	
   ;	    else {
   ;	        if( ndim!=m.nrow ) {
   ;	
@28:
	mov       edx,dword ptr [ebp+8]
	mov       eax,dword ptr [ebp+12]
	mov       ecx,dword ptr [edx+4]
	mov       edx,dword ptr [eax]
	cmp       ecx,edx
	je        short @32
   ;	
   ;	            delete [] v ;
   ;	
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	push      eax
	call      @$bdla$qpv
   ;	
   ;	            ndim=m.nrow ;
   ;	
	mov       edx,dword ptr [ebp+12]
	mov       eax,dword ptr [ebp+8]
	pop       ecx
	mov       ecx,dword ptr [edx]
	mov       dword ptr [eax+4],ecx
   ;	
   ;	            v=new unsigned long[ndim] ;
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx+4]
	shl       ecx,2
	push      ecx
	call      @$bnwa$qui
	pop       ecx
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx],eax
   ;	
   ;	        }
   ;	        wv=w.v ;
   ;	
@32:
	mov       eax,dword ptr [ebp+16]
	mov       ecx,dword ptr [eax]
	mov       dword ptr [ebp-8],ecx
   ;	
   ;	    }
   ;	
   ;	    __asm {
   ;	        mov esi,wv
   ;	
@31:
	mov	 esi,dword ptr [ebp-8]
   ;	
   ;	
   ;	        mov edi,this
   ;	
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov edi,[edi.(class block_vector)v]
   ;	
	mov	 edi,[edi+0]
   ;	
   ;	#else
   ;	        mov edi,[edi+BV_VECTOR]
   ;	#endif
   ;	
   ;	        mov ebx,m
   ;	
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[ebx.(SparseMatrix)nrow]
   ;	
	mov	 ecx,[ebx+0]
   ;	
   ;	#else
   ;	        mov ecx,[ebx+SM_NROW]
   ;	#endif
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	        mov j,ecx
   ;	
	mov	 dword ptr [ebp-12],ecx
   ;	
   ;	
   ;	    }
   ;	OUT_LOOP:
   ;	    __asm {
   ;	//      dec j
   ;	//      js  RET1
   ;	
   ;	        mov ebx,m
   ;	
@33:
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	        mov edx,j
   ;	
	mov	 edx,dword ptr [ebp-12]
   ;	
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[ebx.(class SparseMatrix)w_row]
   ;	
	mov	 ecx,[ebx+12]
   ;	
   ;	#else
   ;	        mov ecx,[ebx+SM_WROW]
   ;	#endif
   ;	        mov ecx,[ecx+4*edx]                                       // ecx <-    w_row[j]
   ;	
	mov	 ecx,[ecx+4*edx]                                       
   ;	
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov eax,[ebx.(class SparseMatrix)mat]
   ;	
	mov	 eax,[ebx+8]
   ;	
   ;	#else
   ;	        mov eax,[ebx+SM_MAT]
   ;	#endif
   ;	        mov ebx,[eax+4*edx]                                    // mat[j]
   ;	
	mov	 ebx,[eax+4*edx]                                    
   ;	
   ;	
   ;	
   ;	        xor edx,edx
   ;	
	xor	 edx,edx
   ;	
   ;	        dec ecx                             // w_row[j]-1
   ;	
	dec	 ecx                             
   ;	
   ;	    }
   ;	INNER_LOOP:
   ;	    __asm {
   ;	//      dec ecx
   ;	//      js  SET_RESULT
   ;	
   ;	        mov eax,[ebx+4*ecx]        // m.mat[j+k]
   ;	
@34:
	mov	 eax,[ebx+4*ecx]        
   ;	
   ;	        mov eax,[esi+4*eax]        // wv[m.mat[j+k]]
   ;	
	mov	 eax,[esi+4*eax]        
   ;	
   ;	
   ;	        xor edx,eax
   ;	
	xor	 edx,eax
   ;	
   ;	
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	        jns INNER_LOOP
   ;	
	jns       short @34
   ;	
   ;	//      jmp INNER_LOOP
   ;	    }
   ;	CONT:
   ;	SET_RESULT:
   ;	    __asm {
   ;	        mov ecx,j
   ;	
	mov	 ecx,dword ptr [ebp-12]
   ;	
   ;	//      mov edx,b
   ;	        mov [edi+4*ecx],edx
   ;	
	mov	 [edi+4*ecx],edx
   ;	
   ;	        dec j
   ;	
	dec	 dword ptr [ebp-12]
   ;	
   ;	        jns OUT_LOOP
   ;	
	jns       @33
   ;	
   ;	//      jmp OUT_LOOP
   ;	
   ;	    }
   ;	RET1:
   ;	
   ;	/********
   ;	
   ;	    for( j=0 ; j<m.nrow ; j++ ) {
   ;	        b=0 ;
   ;	        for( k=0 ; k<m.w_row[j] ; k++ ) {
   ;	            b^=wv[m.mat[j][k]] ;
   ;	        }
   ;	        v[j]=b ;
   ;	    }
   ;	*********/
   ;	    if( same ) delete [] wv ;
   ;	
	mov       al,byte ptr [ebp-1]
	test      al,al
	je        short @35
	mov       edx,dword ptr [ebp-8]
	push      edx
	call      @$bdla$qpv
	pop       ecx
   ;	
   ;	    return *this ;
   ;	
@35:
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	}
   ;	
@37:
@36:
	pop       edi
	pop       esi
	pop       ebx
	mov       esp,ebp
	pop       ebp
	ret 

	align	4
@block_vector@$bmul$qrx12block_vector
   ;	
   ;	block_vector block_vector::operator*(const block_vector& a)
   ;	
@38:
	push      ebp
	mov       ebp,esp
	add       esp,-8
   ;	
   ;	{
   ;	
   ;	/************
   ;	    block_vector ta(ndim) ;
   ;	    unsigned long b ;
   ;	    unsigned long j,k,j32 ;
   ;	    TBit B ;
   ;	
   ;	    for( j=0 ; j<ndim ; j++ ) {
   ;	        b=0 ;
   ;	        B.SetBitString(WordSize,v+j) ;
   ;	        for( k=0 ; k<WordSize ; k++ ) {
   ;	            if( B[k] ) {
   ;	                b^=a.v[k] ;
   ;	            }
   ;	        }
   ;	        ta.v[j]=b ;
   ;	    }
   ;	    return ta ;
   ;	*************/
   ;	    block_vector tb(ndim) ;
   ;	
	mov       eax,dword ptr [ebp+12]
	mov       edx,dword ptr [eax+4]
	push      edx
	lea       ecx,[ebp-8]
	push      ecx
	call      @block_vector@$bctr$qxul
	add       esp,8
   ;	
   ;	    return tb.isMul(*this,a) ;
   ;	
	mov       eax,dword ptr [ebp+16]
	push      eax
	mov       edx,dword ptr [ebp+12]
	push      edx
	lea       ecx,[ebp-8]
	push      ecx
	call      @block_vector@isMul$qrx12block_vectort1
	add       esp,12
	push      eax
	mov       eax,dword ptr [ebp+8]
	push      eax
	call      @block_vector@$bctr$qrx12block_vector
	add       esp,8
	mov       eax,dword ptr [ebp+8]
	push      eax
	push      dword 2
	lea       edx,[ebp-8]
	push      edx
	call      @block_vector@$bdtr$qv
	add       esp,8
	pop       eax
   ;	
   ;	//  if( ta!=tb ) Error(not same result) ;
   ;	}
   ;	
@40:
@39:
	pop       ecx
	pop       ecx
	pop       ebp
	ret 

	align	4
@block_vector@isMul$qrx12block_vectort1
   ;	
   ;	block_vector& block_vector::isMul(const block_vector& a,const block_vector& b)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-12
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	//  unsigned long av ;
   ;	    unsigned long j ;
   ;	//    unsigned long k ;
   ;	    if( this==&b ) return isMul(a,block_vector(b)) ;
   ;	
@41:
	mov       eax,dword ptr [ebp+8]
	cmp       eax,dword ptr [ebp+16]
	jne       short @42
	mov       edx,dword ptr [ebp+16]
	push      edx
	lea       ecx,[ebp-12]
	push      ecx
	call      @block_vector@$bctr$qrx12block_vector
	add       esp,8
	push      eax
	mov       eax,dword ptr [ebp+12]
	push      eax
	mov       edx,dword ptr [ebp+8]
	push      edx
	call      @block_vector@isMul$qrx12block_vectort1
	add       esp,12
	lea       ecx,[ebp-12]
	push      eax
	push      dword 2
	push      ecx
	call      @block_vector@$bdtr$qv
	add       esp,8
	pop       eax
	jmp       @43
   ;	
   ;	/**********
   ;	    unsigned long c,av ;
   ;	    for( j=0 ; j<ndim ; j++ ) {
   ;	        av=a.v[j] ;
   ;	        c=0 ;
   ;	        for( k=0 ; k<WordSize ; k++ ) {
   ;	            __asm {
   ;	                mov ecx,k
   ;	                bt  av,ecx
   ;	                jnc CONT
   ;	            }
   ;	            c^=b.v[k] ;
   ;	CONT:
   ;	        }
   ;	        v[j]=c ;
   ;	    }
   ;	    return *this ;
   ;	************/
   ;	
   ;	    __asm {
   ;	        mov esi,b
   ;	
@42:
	mov	 esi,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov esi,[esi.(class block_vector)v]
   ;	
	mov	 esi,[esi+0]
   ;	
   ;	#else
   ;	        mov esi,[esi+BV_VECTOR]
   ;	#endif
   ;	
   ;	        mov edi,this
   ;	
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov eax,[edi.(class block_vector)ndim]
   ;	
	mov	 eax,[edi+4]
   ;	
   ;	#else
   ;	        mov eax,[edi+BV_NDIM]
   ;	#endif
   ;	        dec eax
   ;	
	dec	 eax
   ;	
   ;	        mov j,eax
   ;	
	mov	 dword ptr [ebp-4],eax
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov edi,[edi.(class block_vector)v]
   ;	
	mov	 edi,[edi+0]
   ;	
   ;	#else
   ;	        mov edi,[edi+BV_VECTOR]
   ;	#endif
   ;	
   ;	        mov ebx,a
   ;	
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ebx,[ebx.(class block_vector)v]
   ;	
	mov	 ebx,[ebx+0]
   ;	
   ;	#else
   ;	        mov ebx,[ebx+BV_VECTOR]
   ;	#endif
   ;	    }
   ;	OUT_LOOP:
   ;	    __asm {
   ;	//      dec j
   ;	//      js  RET1
   ;	        mov ecx,j
   ;	
@44:
	mov	 ecx,dword ptr [ebp-4]
   ;	
   ;	        mov eax,[ebx+4*ecx]    // a.v[j]
   ;	
	mov	 eax,[ebx+4*ecx]    
   ;	
   ;	//      mov av,eax
   ;	
   ;	        xor edx,edx     // c<-0
   ;	
	xor	 edx,edx     
   ;	
   ;	
   ;	        mov ecx,WordSize
   ;	
	mov	 ecx,32
   ;	
   ;	//      dec ecx
   ;	    }
   ;	INNER_LOOP:
   ;	    __asm {
   ;	        dec ecx
   ;	
@45:
	dec	 ecx
   ;	
   ;	        js  SET_RESULT
   ;	
	js        short @46
   ;	
   ;	
   ;	//      bt  av,ecx                                      // Bit(a.v[j],ecx)
   ;	        bt  eax,ecx
   ;	
	bt	  eax,ecx
   ;	
   ;	        jnc INNER_LOOP                              // zero
   ;	
	jae       short @45
   ;	
   ;	
   ;	        xor edx,[esi+4*ecx]
   ;	
	xor	 edx,[esi+4*ecx]
   ;	
   ;	        jmp INNER_LOOP
   ;	
	jmp       short @45
   ;	
   ;	    }
   ;	SET_RESULT:
   ;	    __asm {
   ;	        mov ecx,j
   ;	
@46:
	mov	 ecx,dword ptr [ebp-4]
   ;	
   ;	        mov [edi+4*ecx],edx
   ;	
	mov	 [edi+4*ecx],edx
   ;	
   ;	        dec j
   ;	
	dec	 dword ptr [ebp-4]
   ;	
   ;	        jns OUT_LOOP
   ;	
	jns       @44
   ;	
   ;	//      jmp OUT_LOOP
   ;	
   ;	    }
   ;	RET1:
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	/**************
   ;	    for( j=0 ; j<ndim ; j++ ) {
   ;	        av=a.v[j] ;
   ;	        c=0 ;
   ;	        for( k=0 ; k<WordSize ; k++ ) {
   ;	            __asm {
   ;	                mov ecx,k
   ;	                bt  av,ecx
   ;	                jnc CONT
   ;	            }
   ;	            c^=b.v[k] ;
   ;	CONT:
   ;	        }
   ;	        v[j]=c ;
   ;	    }
   ;	    return *this ;
   ;	***********/
   ;	
   ;	}
   ;	
@47:
@43:
	pop       edi
	pop       esi
	pop       ebx
	mov       esp,ebp
	pop       ebp
	ret 

	align	4
@block_vector@isMulT$qrx12SparseMatrixrx12block_vector
   ;	
   ;	block_vector& block_vector::isMulT(const SparseMatrix& m,const block_vector& w)
   ;	
	push      ebp
	mov       ebp,esp
	push      ecx
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	//  block_vector sv(m.ncol) ;
   ;	//    unsigned long b ;
   ;	    unsigned long j ;
   ;	//    unsigned long k ;
   ;	
   ;	    if( ndim!=m.ncol ) {
   ;	
@48:
	mov       eax,dword ptr [ebp+8]
	mov       ecx,dword ptr [ebp+12]
	mov       edx,dword ptr [eax+4]
	mov       eax,dword ptr [ecx+4]
	cmp       edx,eax
	je        short @49
   ;	
   ;	        if( v ) delete [] v ;
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx]
	test      ecx,ecx
	je        short @50
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax]
	push      edx
	call      @$bdla$qpv
	pop       ecx
   ;	
   ;	        ndim=m.ncol ;
   ;	
@50:
	mov       ecx,dword ptr [ebp+12]
	mov       edx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx+4]
	mov       dword ptr [edx+4],eax
   ;	
   ;	        v=new unsigned long[ndim] ;
   ;	
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx+4]
	shl       eax,2
	push      eax
	call      @$bnwa$qui
	pop       ecx
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx],eax
   ;	
   ;	    }
   ;	
   ;	
   ;	    __asm {
   ;	                                            // initialize *this
   ;	        mov edi,this
   ;	
@49:
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[edi.(class block_vector)ndim]
   ;	
	mov	 ecx,[edi+4]
   ;	
   ;	        mov edi,[edi.(class block_vector)v]
   ;	
	mov	 edi,[edi+0]
   ;	
   ;	#else
   ;	        mov ecx,[edi+BV_NDIM]
   ;	        mov edi,[edi+BV_VECTOR]
   ;	#endif
   ;	        mov esi,edi
   ;	
	mov	 esi,edi
   ;	
   ;	        xor eax,eax
   ;	
	xor	 eax,eax
   ;	
   ;	        rep stosd                                                       // clear this->v
   ;	
	rep stosd	                                                       
   ;	
   ;	
   ;	        mov edi,esi
   ;	
	mov	 edi,esi
   ;	
   ;	
   ;	        mov esi,w
   ;	
	mov	 esi,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov esi,[esi.(class block_vector)v]
   ;	
	mov	 esi,[esi+0]
   ;	
   ;	#else
   ;	        mov esi,[esi+BV_VECTOR]
   ;	#endif
   ;	
   ;	
   ;	        mov ebx,m
   ;	
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[ebx.(SparseMatrix)nrow]
   ;	
	mov	 ecx,[ebx+0]
   ;	
   ;	#else
   ;	        mov ecx,[ebx+SM_NROW]
   ;	#endif
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	        mov j,ecx
   ;	
	mov	 dword ptr [ebp-4],ecx
   ;	
   ;	
   ;	    }
   ;	OUT_LOOP:
   ;	    __asm {
   ;	//      dec j
   ;	//      js  RET1
   ;	
   ;	
   ;	//      mov ecx,j
   ;	//      mov eax,dword ptr [ebx+4*ecx]    // a.v[j]
   ;	//      mov av,eax
   ;	
   ;	
   ;	        mov ebx,m
   ;	
@51:
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	        mov edx,j
   ;	
	mov	 edx,dword ptr [ebp-4]
   ;	
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[ebx.(class SparseMatrix)w_row]
   ;	
	mov	 ecx,[ebx+12]
   ;	
   ;	#else
   ;	        mov ecx,[ebx+SM_WROW]
   ;	#endif
   ;	        mov ecx,[ecx+4*edx]                                       // ecx <-    w_row[j]
   ;	
	mov	 ecx,[ecx+4*edx]                                       
   ;	
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov eax,[ebx.(class SparseMatrix)mat]
   ;	
	mov	 eax,[ebx+8]
   ;	
   ;	#else
   ;	        mov eax,[ebx+SM_MAT]
   ;	#endif
   ;	        mov ebx,[eax+4*edx]                                    // mat[j]
   ;	
	mov	 ebx,[eax+4*edx]                                    
   ;	
   ;	
   ;	        mov edx,[esi+4*edx]                                    // w.v[j]
   ;	
	mov	 edx,[esi+4*edx]                                    
   ;	
   ;	
   ;	
   ;	//      xor edx,edx
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	    }
   ;	INNER_LOOP:
   ;	    __asm {
   ;	//      dec ecx                                                      // ecx=k
   ;	//      js  SET_RESULT
   ;	
   ;	        mov eax,[ebx+4*ecx]        // m.mat[j+k]
   ;	
@52:
	mov	 eax,[ebx+4*ecx]        
   ;	
   ;	
   ;	        xor [edi+4*eax],edx        // v[m.mat[j+k]]^=w.v[j] ;
   ;	
	xor	 [edi+4*eax],edx        
   ;	
   ;	
   ;	
   ;	        dec ecx                                                      // ecx=k
   ;	
	dec	 ecx                                                      
   ;	
   ;	        jns INNER_LOOP
   ;	
	jns       short @52
   ;	
   ;	//      jmp
   ;	    }
   ;	CONT:
   ;	SET_RESULT:
   ;	    __asm {
   ;	//      mov ecx,j
   ;	//      mov edx,b
   ;	//      mov dword ptr [edi+4*ecx],edx
   ;	            dec j
   ;	
	dec	 dword ptr [ebp-4]
   ;	
   ;	            jns OUT_LOOP
   ;	
	jns       @51
   ;	
   ;	//      jmp OUT_LOOP
   ;	
   ;	    }
   ;	RET1:
   ;	/***********
   ;	    for( j=0 ; j<m.nrow ; j++ ) {
   ;	        for( k=0 ; k<m.w_row[j] ; k++ ) {
   ;	            v[m.mat[j+k]]^=w.v[j] ;
   ;	        }
   ;	    }
   ;	***********/
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	
   ;	}
   ;	
@54:
@53:
	pop       edi
	pop       esi
	pop       ebx
	pop       ecx
	pop       ebp
	ret 

	align	4
@block_vector@$badd$qrx12block_vector
   ;	
   ;	block_vector block_vector::operator+(const block_vector& b)
   ;	
@55:
	push      ebp
	mov       ebp,esp
	add       esp,-8
   ;	
   ;	{
   ;	    block_vector s(ndim) ;
   ;	
	mov       eax,dword ptr [ebp+12]
	mov       edx,dword ptr [eax+4]
	push      edx
	lea       ecx,[ebp-8]
	push      ecx
	call      @block_vector@$bctr$qxul
	add       esp,8
   ;	
   ;	    return s.isAdd(*this,b) ;
   ;	
	mov       eax,dword ptr [ebp+16]
	push      eax
	mov       edx,dword ptr [ebp+12]
	push      edx
	lea       ecx,[ebp-8]
	push      ecx
	call      @block_vector@isAdd$qrx12block_vectort1
	add       esp,12
	push      eax
	mov       eax,dword ptr [ebp+8]
	push      eax
	call      @block_vector@$bctr$qrx12block_vector
	add       esp,8
	mov       eax,dword ptr [ebp+8]
	push      eax
	push      dword 2
	lea       edx,[ebp-8]
	push      edx
	call      @block_vector@$bdtr$qv
	add       esp,8
	pop       eax
   ;	
   ;	
   ;	}
   ;	
@57:
@56:
	pop       ecx
	pop       ecx
	pop       ebp
	ret 

	align	4
@block_vector@isAdd$qrx12block_vectort1
   ;	
   ;	block_vector& block_vector::isAdd(const block_vector& a,const block_vector& b)
   ;	
	push      ebp
	mov       ebp,esp
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	    // dimension Ă邩ǂ̃`FbN̓T{
   ;	
   ;	    __asm {
   ;	        mov edi,this
   ;	
@58:
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	        mov esi,a
   ;	
	mov	 esi,dword ptr [ebp+12]
   ;	
   ;	        mov ebx,b
   ;	
	mov	 ebx,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[esi.(class block_vector)ndim]
   ;	
	mov	 ecx,[esi+4]
   ;	
   ;	        mov esi,[esi.(class block_vector)v]
   ;	
	mov	 esi,[esi+0]
   ;	
   ;	        mov edi,[edi.(class block_vector)v]
   ;	
	mov	 edi,[edi+0]
   ;	
   ;	        mov ebx,[ebx.(class block_vector)v]
   ;	
	mov	 ebx,[ebx+0]
   ;	
   ;	#else
   ;	        mov ecx,[esi+BV_NDIM]
   ;	        mov esi,[esi+BV_VECTOR]
   ;	        mov edi,[edi+BV_VECTOR]
   ;	        mov ebx,[ebx+BV_VECTOR]
   ;	#endif
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	    }
   ;	LOOP1:
   ;	    __asm {
   ;	//      dec ecx
   ;	//      js  RET1
   ;	        mov edx,[esi+4*ecx]
   ;	
@59:
	mov	 edx,[esi+4*ecx]
   ;	
   ;	//      mov eax,dword ptr [ebx+4*ecx]
   ;	//      xor edx,eax
   ;	        xor edx,[ebx+4*ecx]
   ;	
	xor	 edx,[ebx+4*ecx]
   ;	
   ;	        mov [edi+4*ecx],edx
   ;	
	mov	 [edi+4*ecx],edx
   ;	
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	        jns LOOP1
   ;	
	jns       short @59
   ;	
   ;	//      jmp LOOP1
   ;	    }
   ;	RET1:
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	//  unsigned long j ;
   ;	//  for( j=0 ; j<ndim ; j++ ) {
   ;	//      v[j]=a.v[j]^b.v[j] ;
   ;	//  }
   ;	//  return *this ;
   ;	}
   ;	
@61:
@60:
	pop       edi
	pop       esi
	pop       ebx
	pop       ebp
	ret 

	align	4
@block_vector@isAND$qrx12block_vectorxul
   ;	
   ;	block_vector& block_vector::isAND(const block_vector& a,const unsigned long c)
   ;	
	push      ebp
	mov       ebp,esp
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	    // dimension Ă邩ǂ̃`FbN̓T{
   ;	
   ;	    __asm {
   ;	        mov edi,this
   ;	
@62:
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	        mov esi,a
   ;	
	mov	 esi,dword ptr [ebp+12]
   ;	
   ;	        mov ebx,c
   ;	
	mov	 ebx,dword ptr [ebp+16]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[esi.(class block_vector)ndim]
   ;	
	mov	 ecx,[esi+4]
   ;	
   ;	        mov esi,[esi.(class block_vector)v]
   ;	
	mov	 esi,[esi+0]
   ;	
   ;	        mov edi,[edi.(class block_vector)v]
   ;	
	mov	 edi,[edi+0]
   ;	
   ;	#else
   ;	        mov ecx,[esi+BV_NDIM]
   ;	        mov esi,[esi+BV_VECTOR]
   ;	        mov edi,[edi+BV_VECTOR]
   ;	#endif
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	    }
   ;	LOOP:
   ;	    __asm {
   ;	//      dec ecx
   ;	//      js  RET1
   ;	        mov edx,[esi+4*ecx]
   ;	
@63:
	mov	 edx,[esi+4*ecx]
   ;	
   ;	        and edx,ebx
   ;	
	and	 edx,ebx
   ;	
   ;	        mov [edi+4*ecx],edx
   ;	
	mov	 [edi+4*ecx],edx
   ;	
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	        jns LOOP
   ;	
	jns       short @63
   ;	
   ;	//      jmp LOOP
   ;	    }
   ;	RET1:
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	
   ;	//  unsigned long j ;
   ;	//  for( j=0 ; j<ndim ; j++ ) {
   ;	//      v[j]=a.v[j]&c ;
   ;	//  }
   ;	//  return *this ;
   ;	}
   ;	
@65:
@64:
	pop       edi
	pop       esi
	pop       ebx
	pop       ebp
	ret 

	align	4
@block_vector@isZero$qv
   ;	
   ;	bool block_vector::isZero(void)
   ;	
	push      ebp
	mov       ebp,esp
	push      ebx
   ;	
   ;	{
   ;	    __asm {
   ;	        mov ebx,this
   ;	
@66:
	mov	 ebx,dword ptr [ebp+8]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov ecx,[ebx.(class block_vector)ndim]
   ;	
	mov	 ecx,[ebx+4]
   ;	
   ;	        mov ebx,[ebx.(class block_vector)v]
   ;	
	mov	 ebx,[ebx+0]
   ;	
   ;	#else
   ;	        mov ecx,[ebx+BV_NDIM]
   ;	        mov ebx,[ebx+BV_VECTOR]
   ;	#endif
   ;	        xor eax,eax                                                 // eax <- 0
   ;	
	xor	 eax,eax                                                 
   ;	
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	    }
   ;	LOOP1:
   ;	    __asm {
   ;	//      dec ecx
   ;	//      js  ZERO
   ;	        cmp [ebx+4*ecx],eax                // zero ?
   ;	
@67:
	cmp	 [ebx+4*ecx],eax                
   ;	
   ;	        jne NOT_ZERO
   ;	
	jne       short @68
   ;	
   ;	        dec ecx
   ;	
	dec	 ecx
   ;	
   ;	        jns LOOP1
   ;	
	jns       short @67
   ;	
   ;	//      jmp LOOP1
   ;	    }
   ;	ZERO:
   ;	    return true ;
   ;	
	mov       al,1
@71:
	pop       ebx
	pop       ebp
	ret 
   ;	
   ;	NOT_ZERO:
   ;	    return false ;
   ;	
@68:
	xor       eax,eax
   ;	
   ;	
   ;	/**********
   ;	    unsigned long j ;
   ;	    for( j=0 ; j<ndim ; j++ ) {
   ;	        if( v[j]!=0 ) return false ;
   ;	    }
   ;	    return true ;
   ;	*********/
   ;	}
   ;	
@70:
@69:
	pop       ebx
	pop       ebp
	ret 

	align	4
@block_vector@isIpro$qrx12block_vectort1
   ;	
   ;	block_vector& block_vector::isIpro(const block_vector& a,const block_vector& b)
   ;	
	push      ebp
	mov       ebp,esp
	push      ecx
	push      ebx
	push      esi
	push      edi
   ;	
   ;	{
   ;	    unsigned long adim ;
   ;	    if( ndim!=WordSize ) {
   ;	
@72:
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	cmp       edx,32
	je        short @73
   ;	
   ;	        delete [] v ;
   ;	
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	push      eax
	call      @$bdla$qpv
	pop       ecx
   ;	
   ;	        ndim=WordSize ;
   ;	
	mov       edx,dword ptr [ebp+8]
	mov       dword ptr [edx+4],32
   ;	
   ;	        v=new unsigned long[WordSize] ;
   ;	
	push      dword ptr 128
	call      @$bnwa$qui
	pop       ecx
	mov       ecx,dword ptr [ebp+8]
	mov       dword ptr [ecx],eax
   ;	
   ;	    }
   ;	
   ;	    __asm {
   ;	
   ;	        mov esi,b
   ;	
@73:
	mov	 esi,dword ptr [ebp+16]
   ;	
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov esi,[esi.(class block_vector)v]
   ;	
	mov	 esi,[esi+0]
   ;	
   ;	
   ;	        mov edi,this
   ;	
	mov	 edi,dword ptr [ebp+8]
   ;	
   ;	        mov edi,[edi.(class block_vector)v]
   ;	
	mov	 edi,[edi+0]
   ;	
   ;	
   ;	        mov ebx,a
   ;	
	mov	 ebx,dword ptr [ebp+12]
   ;	
   ;	        mov eax,[ebx.(class block_vector)ndim]
   ;	
	mov	 eax,[ebx+4]
   ;	
   ;	        mov adim,eax
   ;	
	mov	 dword ptr [ebp-4],eax
   ;	
   ;	        mov ebx,[ebx.(class block_vector)v]
   ;	
	mov	 ebx,[ebx+0]
   ;	
   ;	#else
   ;	        mov esi,[esi+BV_VECTOR]
   ;	
   ;	        mov edi,this
   ;	        mov edi,[edi+BV_VECTOR]
   ;	
   ;	        mov ebx,a
   ;	        mov eax,[ebx+BV_NDIM]
   ;	        mov adim,eax
   ;	        mov ebx,[ebx+BV_VECTOR]
   ;	#endif
   ;	
   ;	        mov eax,WordSize
   ;	
	mov	 eax,32
   ;	
   ;	        dec eax
   ;	
	dec	 eax
   ;	
   ;	
   ;	    }
   ;	OUT_LOOP:
   ;	    __asm {
   ;	//      dec eax
   ;	//      js  RET1
   ;	
   ;	        xor edx,edx                                      // c<-0
   ;	
@74:
	xor	 edx,edx                                      
   ;	
   ;	
   ;	        mov ecx,adim
   ;	
	mov	 ecx,dword ptr [ebp-4]
   ;	
   ;	//      dec ecx
   ;	    }
   ;	INNER_LOOP:
   ;	    __asm {
   ;	        dec ecx
   ;	
@75:
	dec	 ecx
   ;	
   ;	        js  SET_RESULT
   ;	
	js        short @76
   ;	
   ;	
   ;	        bt [ebx+4*ecx],eax
   ;	
	bt	 [ebx+4*ecx],eax
   ;	
   ;	        jnc INNER_LOOP
   ;	
	jae       short @75
   ;	
   ;	
   ;	        xor edx,[esi+4*ecx]    // c^=b.v[k]
   ;	
	xor	 edx,[esi+4*ecx]    
   ;	
   ;	
   ;	//      dec ecx
   ;	//      jns INNER_LOOP
   ;	        jmp INNER_LOOP
   ;	
	jmp       short @75
   ;	
   ;	    }
   ;	CONT:
   ;	SET_RESULT:
   ;	    __asm {
   ;	        mov [edi+4*eax],edx   // v[k]  <- c
   ;	
@76:
	mov	 [edi+4*eax],edx   
   ;	
   ;	        dec eax
   ;	
	dec	 eax
   ;	
   ;	        jns OUT_LOOP
   ;	
	jns       short @74
   ;	
   ;	//      jmp OUT_LOOP
   ;	
   ;	    }
   ;	RET1:
   ;	    return *this ;
   ;	
	mov       eax,dword ptr [ebp+8]
   ;	
   ;	}
   ;	
@78:
@77:
	pop       edi
	pop       esi
	pop       ebx
	pop       ecx
	pop       ebp
	ret 

	align	4
@block_vector@$bmul$qxul
   ;	
   ;	unsigned long block_vector::operator*(const unsigned long pv)
   ;	
@79:
	push      ebp
	mov       ebp,esp
   ;	
   ;	{
   ;	    unsigned long j,k,l ;
   ;	    unsigned long w ;
   ;	    unsigned long p(0) ;
   ;	
	xor       eax,eax
   ;	
   ;	    TBit wB,pB ;
   ;	    wB.SetBitString(WordSize,&w) ;
   ;	
	mov       edx,32
	mov       dword ptr [ebp-20],eax
	mov       dword ptr [ebp-44],edx
	mov       ecx,dword ptr [ebp-44]
	lea       eax,[ebp-16]
	add       ecx,31
   ;	
   ;	    pB.SetBitString(WordSize,&p) ;
   ;	
	mov       edx,32
	sar       ecx,5
	add       esp,-56
	mov       dword ptr [ebp-40],ecx
	mov       dword ptr [ebp-36],eax
	mov       dword ptr [ebp-56],edx
	lea       eax,[ebp-20]
	mov       ecx,dword ptr [ebp-56]
	add       ecx,31
	sar       ecx,5
   ;	
   ;	    for( j=0 ; j<ndim ; j++ ) {
   ;	
	xor       edx,edx
	mov       dword ptr [ebp-52],ecx
	mov       dword ptr [ebp-48],eax
	mov       dword ptr [ebp-4],edx
	jmp       @81
   ;	
   ;	        w=v[j]&pv ;
   ;	
@80:
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	mov       edx,dword ptr [ebp-4]
	mov       ecx,dword ptr [eax+4*edx]
	mov       eax,dword ptr [ebp+12]
	and       ecx,eax
	mov       dword ptr [ebp-16],ecx
   ;	
   ;	        for( l=k=0 ; k<WordSize ; k++ ) {
   ;	
	xor       edx,edx
	mov       dword ptr [ebp-8],edx
	mov       dword ptr [ebp-12],edx
	mov       eax,dword ptr [ebp-8]
	cmp       eax,32
	jae       short @83
   ;	
   ;	            if( wB[k] ) l++ ;
   ;	
@82:
	mov       ecx,dword ptr [ebp-8]
	mov       dword ptr [ebp-24],ecx
	mov       eax,dword ptr [ebp-24]
	push      eax
	mov       edx,dword ptr [ebp-36]
	push      edx
	call      @BitIndex$qpxulxl
	add       esp,8
	test      al,al
	je        short @84
	inc       dword ptr [ebp-12]
@84:
	inc       dword ptr [ebp-8]
	mov       ecx,dword ptr [ebp-8]
	cmp       ecx,32
	jb        short @82
   ;	
   ;	        }
   ;	        if( l&1 ) pB.BitOn(j) ;
   ;	
@83:
	test      byte ptr [ebp-12],1
	je        short @86
	mov       eax,dword ptr [ebp-4]
	mov       dword ptr [ebp-28],eax
	mov       edx,dword ptr [ebp-28]
	push      edx
	mov       ecx,dword ptr [ebp-48]
	push      ecx
	call      @BitOn$qpxulxl
	add       esp,8
	jmp       short @87
   ;	
   ;	        else            pB.BitOff(j) ;
   ;	
@86:
	mov       eax,dword ptr [ebp-4]
	mov       dword ptr [ebp-32],eax
	mov       edx,dword ptr [ebp-32]
	push      edx
	mov       ecx,dword ptr [ebp-48]
	push      ecx
	call      @BitOff$qpxulxl
	add       esp,8
@87:
	inc       dword ptr [ebp-4]
@81:
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	mov       ecx,dword ptr [ebp-4]
	cmp       edx,ecx
;	ja        @80
	jbe short @99_80
	jmp       @80
@99_80
   ;	
   ;	    }
   ;	
   ;	    return p ;
   ;	
	mov       eax,dword ptr [ebp-20]
   ;	
   ;	
   ;	}
   ;	
@90:
@89:
	mov       esp,ebp
	pop       ebp
	ret 

	align	4
@block_vector@$beql$qrx12block_vector
   ;	
   ;	bool block_vector::operator==(const block_vector& b)
   ;	
@91:
	push      ebp
	mov       ebp,esp
	add       esp,-12
   ;	
   ;	{
   ;	    unsigned long j ;
   ;	    if( ndim!=b.ndim ) return false ;
   ;	
	mov       eax,dword ptr [ebp+8]
	mov       edx,dword ptr [eax+4]
	mov       ecx,dword ptr [ebp+12]
	mov       eax,dword ptr [ecx+4]
	cmp       edx,eax
	je        short @92
	xor       eax,eax
	jmp       short @93
   ;	
   ;	    for( j=0 ; j<ndim ; j++ ) {
   ;	
@92:
	xor       edx,edx
	mov       dword ptr [ebp-4],edx
	mov       ecx,dword ptr [ebp+12]
	mov       eax,dword ptr [ecx]
	mov       edx,eax
	mov       dword ptr [ebp-12],edx
	mov       ecx,dword ptr [ebp+8]
	mov       eax,dword ptr [ecx]
	mov       edx,eax
	mov       dword ptr [ebp-8],edx
	jmp       short @95
   ;	
   ;	        if( v[j]!=b.v[j] ) return false ;
   ;	
@94:
	mov       ecx,dword ptr [ebp-8]
	mov       edx,dword ptr [ebp-12]
	mov       eax,dword ptr [ecx]
	mov       ecx,dword ptr [edx]
	cmp       eax,ecx
	je        short @96
	xor       eax,eax
	jmp       short @93
@96:
	inc       dword ptr [ebp-4]
	add       dword ptr [ebp-12],4
	add       dword ptr [ebp-8],4
@95:
	mov       edx,dword ptr [ebp+8]
	mov       ecx,dword ptr [edx+4]
	mov       eax,dword ptr [ebp-4]
	cmp       ecx,eax
	ja        short @94
   ;	
   ;	    }
   ;	    return true ;
   ;	
	mov       al,1
   ;	
   ;	}
   ;	
@98:
@93:
	mov       esp,ebp
	pop       ebp
	ret 

[SECTION .text]
	align	4
@Swap$qr12block_vectort1
   ;	
   ;	void Swap(block_vector& a,block_vector& b)
   ;	
	push      ebp
	mov       ebp,esp
	push      esi
	push      edi
   ;	
   ;	{
   ;	    __asm {
   ;	        mov esi,a
   ;	
@99:
	mov	 esi,dword ptr [ebp+8]
   ;	
   ;	        mov edi,b
   ;	
	mov	 edi,dword ptr [ebp+12]
   ;	
   ;	#ifdef __BORLANDC__
   ;	        mov  eax,[esi.(class block_vector)ndim]
   ;	
	mov	  eax,[esi+4]
   ;	
   ;	        xchg eax,[edi.(class block_vector)ndim]
   ;	
	xchg	 eax,[edi+4]
   ;	
   ;	        mov  [esi.(class block_vector)ndim],eax
   ;	
	mov	  [esi+4],eax
   ;	
   ;	
   ;	        mov  eax,[esi.(class block_vector)v]
   ;	
	mov	  eax,[esi+0]
   ;	
   ;	        xchg eax,[edi.(class block_vector)v]
   ;	
	xchg	 eax,[edi+0]
   ;	
   ;	        mov  [esi.(class block_vector)v],eax
   ;	
	mov	  [esi+0],eax
   ;	
   ;	#else
   ;	
   ;	        mov  eax,[esi+BV_NDIM]
   ;	        xchg eax,[edi]
   ;	        mov  [esi],eax
   ;	
   ;	        mov  eax,[esi+BV_VECTOR]
   ;	        xchg eax,[edi+BV_VECTOR]
   ;	        mov  [esi+BV_VECTOR],eax
   ;	#endif
   ;	    }
   ;	}
   ;	
@100:
	pop       edi
	pop       esi
	pop       ebp
	ret 
