//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  ceil function
//  ceil(x) is maximum integer which is greater than or equal to x.
//
#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Mint.hpp"
#include "Fint.hpp"

Mint ceil(const Fint& f)
{
  Mint::_Mtemp=f ;
  if( sign(f)>0 && sign(f-Mint::_Mtemp)!=0 ) ++Mint::_Mtemp ;
  return Mint::_Mtemp ;
}
