%include "mint.inc"
[BITS 32]
	extrn	@prmdiv$qxul
	public	@eulerphi$qxul
[SECTION .text]	
@eulerphi$qxul
   ;	
   ;	unsigned long eulerphi(const unsigned long n)
   ;	
	push      ebp
	mov       ebp,esp
	add       esp,-8
	push      ebx
	push      edi
   ;	
   ;	{
   ;	  unsigned long phi(1),p ;
   ;	
@1:
	mov       dword ptr [ebp-4],1
   ;	
   ;	
   ;	DO:
   ;	  p=prmdiv(n) ;            // find the smallest divisor
   ;	
@2:
	push      dword ptr [ebp+8]
	call      @prmdiv$qxul
	pop       ecx
	mov       dword ptr [ebp-8],eax
   ;	
   ;	  __asm {
   ;	    mov ebx,p
   ;	
	mov	 ebx,dword ptr [ebp-8]
   ;	
   ;	    mov ecx,phi
   ;	
	mov	 ecx,dword ptr [ebp-4]
   ;	
   ;	    cmp ebx,1              // n is prime
   ;	
	cmp	 ebx,1              
   ;	
   ;	    jnz MORE
   ;	
	jne       short @3
   ;	
   ;	    mov ebx,n
   ;	
	mov	 ebx,dword ptr [ebp+8]
   ;	
   ;	    dec ebx                // n-1
   ;	
	dec	 ebx                
   ;	
   ;	    mov eax,ecx            // eax <- phi
   ;	
	mov	 eax,ecx            
   ;	
   ;	    mul ebx                // phi *= n-1
   ;	
	mul	 ebx                
   ;	
   ;	    mov phi,eax
   ;	
	mov	 dword ptr [ebp-4],eax
   ;	
   ;	    jmp END
   ;	
	jmp       @4
   ;	
   ;	  }
   ;	MORE:
   ;	  __asm {
   ;	    mov eax,ecx            // eax <- phi
   ;	
@3:
	mov	 eax,ecx            
   ;	
   ;	    dec ebx                // p-1
   ;	
	dec	 ebx                
   ;	
   ;	    mul ebx                // phi *= p-1
   ;	
	mul	 ebx                
   ;	
   ;	    mov ecx,eax            // ecx<-phi
   ;	
	mov	 ecx,eax            
   ;	
   ;	    mov eax,dword ptr n
   ;	
	mov	 eax,dword ptr dword ptr [ebp+8]
   ;	
   ;	    xor edx,edx
   ;	
	xor	 edx,edx
   ;	
   ;	    inc ebx
   ;	
	inc	 ebx
   ;	
   ;	    div ebx                // n/p
   ;	
	div	 ebx                
   ;	
   ;	    mov edi,eax            // n <- n/p
   ;	
	mov	 edi,eax            
   ;	
   ;	  }
   ;	LOOP1:
   ;	  __asm {
   ;	    mov eax,edi            // eax <- n
   ;	
@5:
	mov	 eax,edi            
   ;	
   ;	    xor edx,edx
   ;	
	xor	 edx,edx
   ;	
   ;	    div ebx
   ;	
	div	 ebx
   ;	
   ;	//    cmp edx,0              // n%p=0 ?
   ;	    or  edx,edx
   ;	
	or	  edx,edx
   ;	
   ;	    jnz WHILE
   ;	
	jne       short @6
   ;	
   ;	    mov edi,eax            // n <- n/p
   ;	
	mov	 edi,eax            
   ;	
   ;	    mov eax,ecx
   ;	
	mov	 eax,ecx
   ;	
   ;	    mul ebx
   ;	
	mul	 ebx
   ;	
   ;	    mov ecx,eax            // phi <- phi*p
   ;	
	mov	 ecx,eax            
   ;	
   ;	    jmp LOOP1
   ;	
	jmp       @5
   ;	
   ;	  }
   ;	WHILE:
   ;	  __asm {
   ;	    mov dword ptr phi,ecx
   ;	
@6:
	mov	 dword ptr dword ptr [ebp-4],ecx
   ;	
   ;	    cmp edi,1              // n=1 ?
   ;	
	cmp	 edi,1              
   ;	
   ;	    jz  END
   ;	
	je        short @4
   ;	
   ;	    mov dword ptr n,edi
   ;	
	mov	 dword ptr dword ptr [ebp+8],edi
   ;	
   ;	    jmp DO                 // do same thing for next divisor
   ;	
	jmp       @2
   ;	
   ;	  }
   ;	
   ;	END:
   ;	  return phi ;
   ;	
@4:
	mov       eax,dword ptr [ebp-4]
   ;	
   ;	}
   ;	
@8:
@7:
	pop       edi
	pop       ebx
	pop       ecx
	pop       ecx
	pop       ebp
	ret 
