//
//  Copyright (C) 1994 by S.Tomabechi.
//  All rights reserved.
//
//  cubic root r s.t. r^3<= n < (r+1)^3
//
//  3捪̐߂.
//   3悪,^ꂽȉɂȂ鐮ōő̂.
//
#include "Mint.hpp"

Mint icubrt(const Mint& n)
{

  Mint a1,a2(1) ;
  long leng=len(n) ;

  if( leng==0 ) return n ;
  leng=(leng+3)/3 ;
  a2<<=leng ;
  if( sign(n)>0 ) {
    do {
      a1=a2 ;
      a2=(2*a1*a1*a1+n)/(3*a1*a1) ;
    } while( a2<a1 ) ;
  }
  else {
    do {
      a1=a2 ;
      a2=(2*a1*a1*a1-n)/(3*a1*a1) ;
    } while( a2<a1 ) ;
    ~a1 ;
  }
  return a1 ;
}

