#include "Mint.hpp"
#include <iostream.h>
static char q11[11] ;
static char q63[63] ;
static char q64[64] ;
static char q65[65] ;
static bool bSet=false ;

static void SetTable()
{
  int j ;
  for( j=0 ; j<11 ; j++ ) q11[j]=0 ;
  for( j=0 ; j<63 ; j++ ) q63[j]=0 ;
  for( j=0 ; j<64 ; j++ ) q64[j]=0 ;
  for( j=0 ; j<65 ; j++ ) q65[j]=0 ;
  for( j=0 ; j<6  ; j++ ) q11[(j*j)%11]=1 ;
  for( j=0 ; j<32 ; j++ ) q63[(j*j)%63]=1 ;
  for( j=0 ; j<32 ; j++ ) q64[(j*j)%64]=1 ;
  for( j=0 ; j<33 ; j++ ) q65[(j*j)%65]=1 ;
  bSet=true ;
}

Mint SquareTest(const Mint& n)
{
  if( sign(n)<0 ) return -1 ;

  unsigned long t=((unsigned long)n)&63 ;
  unsigned long r ;
  if( !bSet ) SetTable() ;
Test64: ;
  if( q64[t]==0 )  return -1 ;  // n is not square
  r=n%45045L ;

Test63: ;
  if( q63[r%63]==0 ) return -1 ;

Test65: ;
  if( q65[r%65]==0 ) return -1 ;

Test11: ;
  if( q11[r%11]==0 ) return -1 ;


  Mint q=isqrt(n) ;
  if( square(q)!=n ) return -1 ;
  else return q ;
//  else { cout << endl << " isqrt " ;return q ; }
}

#if 0
#include <stdlib.h>

void main(void)
{
  Mint n,m ;
  long j ;
//  SetTable() ;
  for( n=1,j=0 ; j<1000000 ; j++,n++ ) {
    m=SquareTest(n) ;
//    if( m!=0 ) cout << endl << n ;
//  if( m==0 ) cout << endl << n ;
/*********************
    if( m==0 ) cout << endl << "not square " << n ;
    else cout << endl << "square     " << n ;
*********************/
  }

}
#endif