//
//  Copyright (C) by S.Tomabechi 1994,1997
//  All rights reserved.
//
//  _̑
//
//  BC++ ł́Along double ̌^邪
//  VC++ ł́Along double=double ł
//
#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Mint.hpp"
#include "Fint.hpp"
#include "LDbl.hpp"
#include "Dbl.hpp"
#include "IntFuncs.hpp"


#ifdef __BORLANDC__
Fint& Fint::operator=(const long double& d)
{
  LDbl D(d) ;
  long e,k(2) ;

       // ̏ꍇ̏YĂ 1995.05.11
  if( D.isZero() ) {
    nDigit=0 ;
    nDim&=_POSITIVE_ ;
    goto RET ;
  }

  if( fDigit<k ) fDigit=k ;   // ȂƂ_ȉ񌅂Ƃ

  if( ndim()<=fDigit ) allocate(fDigit+1) ;// m

  if( D.Sign()>0 ) nDim&=_POSITIVE_  ;
  else nDim|=_NEGATIVE_ ;
#ifdef __BORLANDC__
  digit[fDigit]=0 ;
  nDigit=fDigit ;
#else
  digit[fDigit]=1 ;
  nDigit=fDigit+1 ;
#endif
  digit[fDigit-1]=D.High() ;
  digit[fDigit-2]=D.Low() ;
  for( k=0 ; k<fDigit-2 ; k++ ) digit[k]=0 ;   // ؎̂
#ifdef __BORLANDC__
  e=D.Exp()+1 ;
#else
  e=D.Exp() ;
#endif

  if( e>=0 ) isShiftl(*this,e) ;
  else {                         // _ȉ̗̈m
    if( (k=(fDigit<<5)-64+e)<0 ) (*this)[(-k+31)>>5] ;
    (*this)>>=(-e) ;
  }
RET:
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

#endif

Fint& Fint::operator=(const double& d)
{
  Dbl D(d) ;
  long e,k(2) ;

  // ̏ꍇ̏YĂ 1995.05.11
  if( D.isZero() ) {
    nDigit=0 ;
    nDim&=_POSITIVE_ ;
    goto RET ;
  }


  if( fDigit<k ) fDigit=k ;   // ȂƂ_ȉ񌅂Ƃ

  if( ndim()<=fDigit ) allocate(fDigit+1) ; // m

  if( D.Sign()>0 ) nDim&=_POSITIVE_ ;
  else nDim|=_NEGATIVE_ ;
  nDigit=fDigit+1 ;
  digit[fDigit]=1 ;
  digit[fDigit-1]=D.High() ;
  digit[fDigit-2]=D.Low() ;
  for( k=0 ; k<fDigit-2 ; k++ ) digit[k]=0 ;   // ؎̂
  e=D.Exp() ;

  if( e>=0 ) isShiftl(*this,e) ; // ((*this)<<=e) ;
  else {                         // _ȉ̗̈m
    if( (k=((long(fDigit)<<5)-64+e))<0 ) (*this)[(-k+31)>>5] ;
    (*this)>>=(-e) ;
  }
RET:
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}

