//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  floor function
//  floor(x) is maximum integer which is less than or equal to x.
//
#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Mint.hpp"
#include "Fint.hpp"

Mint floor(const Fint& f)
{
  Mint::_Mtemp=Int(f) ;
  if( sign(f)<0 && !((f-Mint::_Mtemp).isZero()) ) --Mint::_Mtemp ;
  return Mint::_Mtemp ;
}
