//
//  Copyright (C) by S.Tomabechi 1993,1997
//  All rights reserved.
//
//  calculate power mod p  x^n mod p
//
//  1997/05/30
//     ѻؿΤȤϡmod p ǤεտѤ׻褦ˤ
//
//    &x=&n 뤤 &x=&p ǤäƤϤʤʤ
//
#include "Mint.hpp"
#include "Error.hpp"

Mint& Mint::power(const Mint& x,const Mint& n,const Mint& p)
{

  long j(0),k ;
  unsigned long d ;
  long leng=ilog2(n) ;

  if( !n.isNegative() ) Mint::_uuMtemp=x ;   // n>=0
  else {
    Mint::_uuMtemp.isInvModp(x,p) ;          // inverse x^-1 mod p
    if( Mint::_uuMtemp.isZero() ) Error(x is zerodivisor) ;
  }

         // this=&x ξ礬Τ x 򥳥ԡȤ 1 򥻥å
  nDim&=_POSITIVE_ ;
  nDigit=1 ;
  *digit=1 ;

  if( leng>=0 ) for(;;) {
    d=n.digit[j++] ;
    for( k=32 ; k!=0 ; k-- ) {
      if( d&1 )
        (*this*=Mint::_uuMtemp)&=p ;  // Ǿ;
      if( --leng<0 ) goto RET1 ;
       d>>=1 ;
      Mint::_uuMtemp.isSquare(Mint::_uuMtemp)&=p ;
    }
  }
RET1: ;
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
//_MemMan.check(__FILE__,__LINE__) ;
#endif
  return *this ;

}

